/*****************************************************************************
 *                   SEGGER Microcontroller GmbH & Co. KG                    *
 *            Solutions for real time microcontroller applications           *
 *****************************************************************************
 *                                                                           *
 *               (c) 2017 SEGGER Microcontroller GmbH & Co. KG               *
 *                                                                           *
 *           Internet: www.segger.com   Support: support@segger.com          *
 *                                                                           *
 *****************************************************************************/

function Reset() {
  TargetInterface.resetAndStop();
}

function EnableExtSDRAM() {
  // Enable CCM, GPIOC, GPIOD, GPIOE, GPIOF, GPIOG and GPIOH interface clock 
  TargetInterface.pokeWord(0x40023830, 0x001000FC);   // RCC->AHB1ENR
  
  // Enable FMC clock
  TargetInterface.pokeWord(0x40023838, 0x00000001);   // RCC->AHB3ENR
  
  // Connect PCx pins to FSMC Alternate function 
  TargetInterface.pokeWord(0x40020820, 0x0000C000);   // GPIOC->AFR[0]
  TargetInterface.pokeWord(0x40020824, 0x00000000);   // GPIOC->AFR[1]  
  // Configure PDx pins in Alternate function mode   
  TargetInterface.pokeWord(0x40020800, 0x00000080);   // GPIOC->MODER
  // Configure PDx pins speed to 100 MHz   
  TargetInterface.pokeWord(0x40020808, 0x00000080);   // GPIOC->OSPEEDR
  // Configure PDx pins Output type to push-pull   
  TargetInterface.pokeWord(0x40020804, 0x00000000);   // GPIOC->OTYPER
  // No pull-up, pull-down for PDx pins  
  TargetInterface.pokeWord(0x4002080C, 0x00000040);   // GPIOC->PUPDR
  
  
  // Connect PDx pins to FSMC Alternate function 
  TargetInterface.pokeWord(0x40020C20, 0x000000CC);   // GPIOD->AFR[0]
  TargetInterface.pokeWord(0x40020C24, 0xCC000CCC);   // GPIOD->AFR[1]  
  // Configure PDx pins in Alternate function mode   
  TargetInterface.pokeWord(0x40020C00, 0xA02A000A);   // GPIOD->MODER
  // Configure PDx pins speed to 100 MHz   
  TargetInterface.pokeWord(0x40020C08, 0xA02A000A);   // GPIOD->OSPEEDR
  // Configure PDx pins Output type to push-pull   
  TargetInterface.pokeWord(0x40020C04, 0x00000000);   // GPIOD->OTYPER
  // No pull-up, pull-down for PDx pins  
  TargetInterface.pokeWord(0x40020C0C, 0x50150005);   // GPIOD->PUPDR
  

  // Connect PEx pins to FSMC Alternate function 
  TargetInterface.pokeWord(0x40021020, 0xC00000CC);   // GPIOE->AFR[0]
  TargetInterface.pokeWord(0x40021024, 0xCCCCCCCC);   // GPIOE->AFR[1]
  // Configure PEx pins in Alternate function mode  
  TargetInterface.pokeWord(0x40021000, 0xAAAA800A);   // GPIOE->MODER
  // Configure PEx pins speed to 50 MHz  
  TargetInterface.pokeWord(0x40021008, 0xAAAA800A);   // GPIOE->OSPEEDR
  // Configure PEx pins Output type to push-pull   
  TargetInterface.pokeWord(0x40021004, 0x00000000);   // GPIOE->OTYPER
  // No pull-up, pull-down for PEx pins  
  TargetInterface.pokeWord(0x4002100C, 0x55554005);   // GPIOE->PUPDR


  // Connect PFx pins to FSMC Alternate function 
  TargetInterface.pokeWord(0x40021420, 0x00CCCCCC);   // GPIOF->AFR[0]
  TargetInterface.pokeWord(0x40021424, 0xCCCCC000);   // GPIOF->AFR[1]
  // Configure PFx pins in Alternate function mode    
  TargetInterface.pokeWord(0x40021400, 0xAA800AAA);   // GPIOF->MODER
  // Configure PFx pins speed to 100 MHz  
  TargetInterface.pokeWord(0x40021408, 0xAA800AAA);   // GPIOF->OSPEEDR
  // Configure PFx pins Output type to push-pull   
  TargetInterface.pokeWord(0x40021404, 0x00000000);   // GPIOF->OTYPER
  // No pull-up, pull-down for PFx pins  
  TargetInterface.pokeWord(0x4002140C, 0x55400555);   // GPIOF->PUPDR


  // Connect PGx pins to FSMC Alternate function 
  TargetInterface.pokeWord(0x40021820, 0x00CC00CC);   // GPIOG->AFR[0]
  TargetInterface.pokeWord(0x40021824, 0xC000000C);   // GPIOG->AFR[1]
  // Configure PGx pins in Alternate function mode  
  TargetInterface.pokeWord(0x40021800, 0x80020A0A);   // GPIOG->MODER
  // Configure PGx pins speed to 50 MHz  
  TargetInterface.pokeWord(0x40021808, 0x80020A0A);   // GPIOG->OSPEEDR
  // Configure PGx pins Output type to push-pull   
  TargetInterface.pokeWord(0x40021804, 0x00000000);   // GPIOG->OTYPER
  // No pull-up, pull-down for PGx pins  
  TargetInterface.pokeWord(0x4002180C, 0x40010505);   // GPIOG->PUPDR


  // Connect PHx pins to FSMC Alternate function 
  TargetInterface.pokeWord(0x40021C20, 0x00C0C000);   // GPIOH->AFR[0]
  TargetInterface.pokeWord(0x40021C24, 0x00000000);   // GPIOH->AFR[1]
  // Configure PGx pins in Alternate function mode  
  TargetInterface.pokeWord(0x40021C00, 0x00000880);   // GPIOH->MODER
  // Configure PGx pins speed to 50 MHz  
  TargetInterface.pokeWord(0x40021C08, 0x00000880);   // GPIOH->OSPEEDR
  // Configure PGx pins Output type to push-pull   
  TargetInterface.pokeWord(0x40021C04, 0x00000000);   // GPIOH->OTYPER
  // No pull-up, pull-down for PGx pins  
  TargetInterface.pokeWord(0x40021C0C, 0x00000440);   // GPIOH->PUPDR
  
  //-- FSMC Configuration --------------------------------
  // Enable the FSMC interface clock 
  TargetInterface.pokeWord(0x40023838, 0x00000001);   // RCC->AHB3ENR

  // Configure and enable SDRAM bank1 
  TargetInterface.pokeWord(0xA0000140, 0x00001954);   // FMC_Bank5_6->SDCR[0] 
  TargetInterface.pokeWord(0xA0000148, 0x01116361);   // FMC_Bank5_6->SDTR[0] 
  
  // SDRAM initialization sequence
  
  //Clock enable command
  TargetInterface.pokeWord(0xA0000150, 0x00000011);   // FMC_Bank5_6->SDCMR
  
  // Delay
  TargetInterface.delay(100);
  
  // PALL command
  TargetInterface.pokeWord(0xA0000150, 0x00000012);   // FMC_Bank5_6->SDCMR 
  TargetInterface.delay(10);
  
  // Auto refresh command
  TargetInterface.pokeWord(0xA0000150, 0x000000F3);   // FMC_Bank5_6->SDCMR 
  TargetInterface.delay(10);
  
  // MRD register program
  TargetInterface.pokeWord(0xA0000150, 0x00044014);   // FMC_Bank5_6->SDCMR 
  TargetInterface.delay(10);
  
  // Set refresh count
  TargetInterface.pokeWord(0xA0000154, 0x00000A18);   // FMC_Bank5_6->SDRTR 
  
  // Disable write protection
  //TargetInterface.pokeWord(0xA0000140, 0x00001954);   // FMC_Bank5_6->SDCR[0] 
  
}

function SDRAM_Reset() {
  Reset();
  EnableExtSDRAM();
}

function EnableTrace(traceInterfaceType) {
  // TODO: Enable trace
}

